using System;
using System.Collections;

namespace Geometry
{
	/// <summary>
	/// Summary description for BaseBoxTree.
	/// </summary>
	public class BaseBoxTree:IEnumerable
	{
    private BoxTree mBoxTree;

    public static implicit operator BoxTree(BaseBoxTree tree)
    {
      return tree.mBoxTree;
    }
    public int Count
    {
      get
      { return mBoxTree.Count; }
    }
		public BaseBoxTree(int dimension)
		{
      mBoxTree = new BoxTree(dimension);
		}

    public BaseBoxTree(int dimension,int nElem,bool dynamic)
    {
      mBoxTree = new BoxTree(dimension,nElem,dynamic);
    }

    protected BoxTree BoxTree
    {
      get
      { return mBoxTree; }
    }

    public IEnumerator GetEnumerator()
    {
      return mBoxTree.GetEnumerator();
    }
	}
}
