﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using Grid;

namespace GPSLearning
{
  public class KeyFeatureTestSet : ISerializable
  {
    public List<TrainingInstance> Tests;

    public KeyFeatureTestSet()
    {
      Tests = new List<TrainingInstance>();
    }

    public void Add(TrainingInstance testInstance)
    {
      Tests.Add(testInstance);
    }

    public void Remove(TrainingInstance testInstance)
    {
      Tests.Remove(testInstance);
    }

    public void Clear()
    {
      Tests.Clear();
    }

    public KeyFeatureTestSet(SerializationInfo info, StreamingContext context)
    {
      Tests = (List<TrainingInstance>)info.GetValue("Tests", typeof(List<TrainingInstance>));
    }

    public void GetObjectData(SerializationInfo info, StreamingContext context)
    {
      info.AddValue("Tests", Tests);
    }

    public double[][] GetInput(InputVectorType inputVectorType, bool normalizeInputVector)
    {
      var input = new double[Tests.Count][];
      for (int i = 0; i < Tests.Count; i++)
      {
        ClassifiedMapPointFeatures cmf = Tests[i].ClassifiedMapFeatures;
        double climb = Tests[i].Climb;
        double slope = Tests[i].Slope;
        input[i] = TrainingSet.CreateInputVector(cmf, climb, slope, inputVectorType, normalizeInputVector);
      }
      return input;
    }
  }
}
