﻿using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Xml.Serialization;


namespace GPSLearning
{
  public class TrainingSetSerializer
  {
    public static void SerializeToBinary(string filename, TrainingSet trainingSet)
    {
      Stream stream = File.Open(filename, FileMode.Create);
      var bFormatter = new BinaryFormatter();
      bFormatter.Serialize(stream, trainingSet);
      stream.Close();
    }

    public static TrainingSet DeserializeFromBinary(string filename)
    {
      Stream stream = File.Open(filename, FileMode.Open);
      var bFormatter = new BinaryFormatter();
      var trainingSet = (TrainingSet)bFormatter.Deserialize(stream);
      stream.Close();
      return trainingSet;
    }

    public static void SerializeToXml(string filename, TrainingSet trainingSet)
    {
      var serializer = new XmlSerializer(typeof(TrainingSet));
      TextWriter textWriter = new StreamWriter(filename);
      serializer.Serialize(textWriter, trainingSet);
      textWriter.Close();
    }

    public static TrainingSet DeserializeFromXml(string filename)
    {
      var deserializer = new XmlSerializer(typeof(TrainingSet));
      TextReader textReader = new StreamReader(filename);
      var trainingSet = (TrainingSet)deserializer.Deserialize(textReader);
      textReader.Close();
      return trainingSet;
    }

    public static void SerializeKeyFeatureTestSetToXml(string filename, KeyFeatureTestSet testSet)
    {
      var serializer = new XmlSerializer(typeof(KeyFeatureTestSet));
      TextWriter textWriter = new StreamWriter(filename);
      serializer.Serialize(textWriter, testSet);
      textWriter.Close();
    }

    public static KeyFeatureTestSet DeserializeKeyFeatureTestSetFromXml(string filename)
    {
      var deserializer = new XmlSerializer(typeof(KeyFeatureTestSet));
      TextReader textReader = new StreamReader(filename);
      var testSet = (KeyFeatureTestSet)deserializer.Deserialize(textReader);
      textReader.Close();
      return testSet;
    }
  }
}
