﻿using System;
using System.Linq;
using System.Collections.Generic;

namespace GPSLearning
{
  static class Utilities
  {
    public static void Shuffle<T>(IList<T> list)  
    {  
      var rng = new Random();  
      int n = list.Count;  
      while (n > 1) {  
        n--;  
        int k = rng.Next(n + 1);  
        T value = list[k];  
        list[k] = list[n];  
        list[n] = value;  
      }  
    }

    public static double Sum(IList<double> values)
    {
      double sum = 0.0;
      foreach (var d in values)
      {
        sum += d;
      }
      return sum;
    }

    public static double Average(IList<double> values)
    {
      return Sum(values)/values.Count;
    }

    public static double StandardDeviation(IList<double> values)
    {
      double stdDev = 0;
      if (values.Count > 0)
      {
        double avg = Average(values);
        var diffFromAvg = new List<double>();
        foreach (double v in values)
        {
          diffFromAvg.Add(Math.Pow(v - avg, 2));
        }
        stdDev = Math.Sqrt(Average(diffFromAvg));
      }
      return stdDev;
    }
  
  }

}
