﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Imaging;

namespace Grid
{
  /// <summary>
  /// A DoubleGrid in which the double value at each coordinate encodes the presence
  /// of a certain map feature at that coordinate.
  /// </summary>
  public class FeatureGrid : DoubleGrid
  {
    protected ImageGrid _img;

    public static FeatureGrid FromImage(string name)
    {
      ImageGrid img = ImageGrid.FromFile(name);
      return new FeatureGrid(img);
    }
    protected FeatureGrid(ImageGrid img)
      : base(img.Extent)
    {
      _img = img;
    }

    public void LockBits()
    {
      _img.LockBits();
    }
    public void UnlockBits()
    {
      _img.UnlockBits();
    }

    public override double this[int ix, int iy]
    {
      get
      {
        Color pCol = _img[ix, iy];
        return pCol.R / 255.0;
      }

      set
      {
      }
    }

    public void Close()
    {
      _img.Close();
    }
  }
}
