using System;
using System.Windows.Forms;
using System.IO;
using Mathe.Geom;
using Grid;

namespace LeastCostPathUI
{
  /// <summary>
  /// Summary description for OutGrid.
  /// </summary>
  public class CntOutGrid : UserControl
  {
    private bool _inSynchron = false;
    private string _mainPath = "";
    /// <summary>
    /// designer variables
    /// </summary>
    private CheckBox chkSynchron;
    private CheckBox chkCost;
    private CheckBox chkCostImg;
    private CheckBox chkDir;
    private CheckBox chkDirImg;
    private TextBox txtCost;
    private TextBox txtCostImg;
    private TextBox txtDir;
    private TextBox txtDirImg;
    private Button btnCost;
    private Button btnCostImg;
    private Button btnDir;
    private Button btnDirImg;
    public SaveFileDialog dlgSave;
    private TextBox txtX;
    private TextBox txtY;
    private Label lblX;
    private Label lblY;
    private Panel grpCoord;
    /// <summary> 
    /// Required designer variable.
    /// </summary>
    private System.ComponentModel.Container components = null;

    public CntOutGrid()
    {
      // This call is required by the Windows.Forms Form Designer.
      InitializeComponent();
    }

    /// <summary> 
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose(bool disposing)
    {
      if (disposing)
      {
        if (components != null)
        {
          components.Dispose();
        }
      }
      base.Dispose(disposing);
    }

    #region Component Designer generated code
    /// <summary> 
    /// Required method for Designer support - do not modify 
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(CntOutGrid));
      this.chkSynchron = new System.Windows.Forms.CheckBox();
      this.chkCost = new System.Windows.Forms.CheckBox();
      this.chkCostImg = new System.Windows.Forms.CheckBox();
      this.chkDir = new System.Windows.Forms.CheckBox();
      this.chkDirImg = new System.Windows.Forms.CheckBox();
      this.txtCost = new System.Windows.Forms.TextBox();
      this.txtCostImg = new System.Windows.Forms.TextBox();
      this.txtDir = new System.Windows.Forms.TextBox();
      this.txtDirImg = new System.Windows.Forms.TextBox();
      this.btnCost = new System.Windows.Forms.Button();
      this.btnCostImg = new System.Windows.Forms.Button();
      this.btnDir = new System.Windows.Forms.Button();
      this.btnDirImg = new System.Windows.Forms.Button();
      this.dlgSave = new System.Windows.Forms.SaveFileDialog();
      this.txtX = new System.Windows.Forms.TextBox();
      this.txtY = new System.Windows.Forms.TextBox();
      this.lblX = new System.Windows.Forms.Label();
      this.lblY = new System.Windows.Forms.Label();
      this.grpCoord = new System.Windows.Forms.Panel();
      this.grpCoord.SuspendLayout();
      this.SuspendLayout();
      // 
      // chkSynchron
      // 
      this.chkSynchron.Checked = true;
      this.chkSynchron.CheckState = System.Windows.Forms.CheckState.Checked;
      this.chkSynchron.Location = new System.Drawing.Point(0, 0);
      this.chkSynchron.Name = "chkSynchron";
      this.chkSynchron.Size = new System.Drawing.Size(128, 16);
      this.chkSynchron.TabIndex = 0;
      this.chkSynchron.Text = "Synchronize names";
      // 
      // chkCost
      // 
      this.chkCost.Location = new System.Drawing.Point(16, 24);
      this.chkCost.Name = "chkCost";
      this.chkCost.Size = new System.Drawing.Size(104, 16);
      this.chkCost.TabIndex = 1;
      this.chkCost.Text = "Cost";
      // 
      // chkCostImg
      // 
      this.chkCostImg.Location = new System.Drawing.Point(16, 48);
      this.chkCostImg.Name = "chkCostImg";
      this.chkCostImg.Size = new System.Drawing.Size(104, 16);
      this.chkCostImg.TabIndex = 2;
      this.chkCostImg.Text = "Cost Image";
      // 
      // chkDir
      // 
      this.chkDir.Location = new System.Drawing.Point(16, 72);
      this.chkDir.Name = "chkDir";
      this.chkDir.Size = new System.Drawing.Size(104, 16);
      this.chkDir.TabIndex = 3;
      this.chkDir.Text = "Direction";
      // 
      // chkDirImg
      // 
      this.chkDirImg.Location = new System.Drawing.Point(16, 96);
      this.chkDirImg.Name = "chkDirImg";
      this.chkDirImg.Size = new System.Drawing.Size(104, 16);
      this.chkDirImg.TabIndex = 4;
      this.chkDirImg.Text = "Direction Image";
      // 
      // txtCost
      // 
      this.txtCost.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.txtCost.Location = new System.Drawing.Point(136, 24);
      this.txtCost.Name = "txtCost";
      this.txtCost.Size = new System.Drawing.Size(256, 20);
      this.txtCost.TabIndex = 5;
      this.txtCost.Text = "*c.grd";
      this.txtCost.TextChanged += new System.EventHandler(this.txtCost_TextChanged);
      // 
      // txtCostImg
      // 
      this.txtCostImg.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.txtCostImg.Location = new System.Drawing.Point(136, 48);
      this.txtCostImg.Name = "txtCostImg";
      this.txtCostImg.Size = new System.Drawing.Size(256, 20);
      this.txtCostImg.TabIndex = 6;
      this.txtCostImg.Text = "*c.tif";
      this.txtCostImg.TextChanged += new System.EventHandler(this.txtCostImg_TextChanged);
      // 
      // txtDir
      // 
      this.txtDir.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.txtDir.Location = new System.Drawing.Point(136, 72);
      this.txtDir.Name = "txtDir";
      this.txtDir.Size = new System.Drawing.Size(256, 20);
      this.txtDir.TabIndex = 7;
      this.txtDir.Text = "*d.grd";
      this.txtDir.TextChanged += new System.EventHandler(this.txtDir_TextChanged);
      // 
      // txtDirImg
      // 
      this.txtDirImg.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.txtDirImg.Location = new System.Drawing.Point(136, 96);
      this.txtDirImg.Name = "txtDirImg";
      this.txtDirImg.Size = new System.Drawing.Size(256, 20);
      this.txtDirImg.TabIndex = 8;
      this.txtDirImg.Text = "*d.tif";
      this.txtDirImg.TextChanged += new System.EventHandler(this.txtDirImg_TextChanged);
      // 
      // btnCost
      // 
      this.btnCost.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
      this.btnCost.Image = ((System.Drawing.Image)(resources.GetObject("btnCost.Image")));
      this.btnCost.Location = new System.Drawing.Point(392, 24);
      this.btnCost.Name = "btnCost";
      this.btnCost.Size = new System.Drawing.Size(20, 20);
      this.btnCost.TabIndex = 9;
      this.btnCost.Click += new System.EventHandler(this.btnCost_Click);
      // 
      // btnCostImg
      // 
      this.btnCostImg.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
      this.btnCostImg.Image = ((System.Drawing.Image)(resources.GetObject("btnCostImg.Image")));
      this.btnCostImg.Location = new System.Drawing.Point(392, 48);
      this.btnCostImg.Name = "btnCostImg";
      this.btnCostImg.Size = new System.Drawing.Size(20, 20);
      this.btnCostImg.TabIndex = 10;
      this.btnCostImg.Click += new System.EventHandler(this.btnCostImg_Click);
      // 
      // btnDir
      // 
      this.btnDir.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
      this.btnDir.Image = ((System.Drawing.Image)(resources.GetObject("btnDir.Image")));
      this.btnDir.Location = new System.Drawing.Point(392, 72);
      this.btnDir.Name = "btnDir";
      this.btnDir.Size = new System.Drawing.Size(20, 20);
      this.btnDir.TabIndex = 11;
      this.btnDir.Click += new System.EventHandler(this.btnDir_Click);
      // 
      // btnDirImg
      // 
      this.btnDirImg.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
      this.btnDirImg.Image = ((System.Drawing.Image)(resources.GetObject("btnDirImg.Image")));
      this.btnDirImg.Location = new System.Drawing.Point(392, 96);
      this.btnDirImg.Name = "btnDirImg";
      this.btnDirImg.Size = new System.Drawing.Size(20, 20);
      this.btnDirImg.TabIndex = 12;
      this.btnDirImg.Click += new System.EventHandler(this.btnDirImg_Click);
      // 
      // txtX
      // 
      this.txtX.Location = new System.Drawing.Point(24, 0);
      this.txtX.Name = "txtX";
      this.txtX.Size = new System.Drawing.Size(80, 20);
      this.txtX.TabIndex = 13;
      this.txtX.Text = "0";
      this.txtX.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
      // 
      // txtY
      // 
      this.txtY.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
      this.txtY.Location = new System.Drawing.Point(176, 0);
      this.txtY.Name = "txtY";
      this.txtY.Size = new System.Drawing.Size(80, 20);
      this.txtY.TabIndex = 14;
      this.txtY.Text = "0";
      this.txtY.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
      // 
      // lblX
      // 
      this.lblX.Location = new System.Drawing.Point(0, 0);
      this.lblX.Name = "lblX";
      this.lblX.Size = new System.Drawing.Size(24, 16);
      this.lblX.TabIndex = 15;
      this.lblX.Text = "X";
      // 
      // lblY
      // 
      this.lblY.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
      this.lblY.Location = new System.Drawing.Point(152, 0);
      this.lblY.Name = "lblY";
      this.lblY.Size = new System.Drawing.Size(24, 16);
      this.lblY.TabIndex = 16;
      this.lblY.Text = "Y";
      // 
      // grpCoord
      // 
      this.grpCoord.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.grpCoord.Controls.Add(this.txtX);
      this.grpCoord.Controls.Add(this.lblX);
      this.grpCoord.Controls.Add(this.txtY);
      this.grpCoord.Controls.Add(this.lblY);
      this.grpCoord.Location = new System.Drawing.Point(136, 0);
      this.grpCoord.Name = "grpCoord";
      this.grpCoord.Size = new System.Drawing.Size(256, 24);
      this.grpCoord.TabIndex = 17;
      // 
      // CntOutGrid
      // 
      this.Controls.Add(this.grpCoord);
      this.Controls.Add(this.btnDirImg);
      this.Controls.Add(this.btnDir);
      this.Controls.Add(this.btnCostImg);
      this.Controls.Add(this.btnCost);
      this.Controls.Add(this.txtDirImg);
      this.Controls.Add(this.txtDir);
      this.Controls.Add(this.txtCostImg);
      this.Controls.Add(this.txtCost);
      this.Controls.Add(this.chkDirImg);
      this.Controls.Add(this.chkDir);
      this.Controls.Add(this.chkCostImg);
      this.Controls.Add(this.chkCost);
      this.Controls.Add(this.chkSynchron);
      this.Name = "CntOutGrid";
      this.Size = new System.Drawing.Size(416, 120);
      this.grpCoord.ResumeLayout(false);
      this.grpCoord.PerformLayout();
      this.ResumeLayout(false);
      this.PerformLayout();

    }
    #endregion

    public bool ShowCoordinates
    {
      get
      { return grpCoord.Visible; }
      set
      { grpCoord.Visible = value; }
    }

    public void SetPoint(IPoint pnt)
    {
      X = pnt.X;
      Y = pnt.Y;
    }

    public void SetName(string name)
    {
      txtCost.Text = name + "c.grd";
    }

    public void SetMainPath(string mainPath)
    {
      _mainPath = mainPath;
    }
    public double X
    {
      get
      { return Convert.ToDouble(txtX.Text); }
      set
      { txtX.Text = value.ToString(); }
    }
    public double Y
    {
      get
      { return Convert.ToDouble(txtY.Text); }
      set
      { txtY.Text = value.ToString(); }
    }

    public string CostGrid
    {
      get
      {
        if (chkCost.Checked == false) return null;
        return FullName(txtCost.Text);
      }
    }
    public string CostImage
    {
      get
      {
        if (chkCostImg.Checked == false) return null;
        return FullName(txtCostImg.Text);
      }
    }
    public string DirGrid
    {
      get
      {
        if (chkDir.Checked == false) return null;
        return FullName(txtDir.Text);
      }
    }
    public string DirImage
    {
      get
      {
        if (chkDirImg.Checked == false) return null;
        return FullName(txtDirImg.Text);
      }
    }

    public void CheckCost(bool check)
    {
      chkCost.Checked = check;
    }
    public void CheckCostImage(bool check)
    {
      chkCostImg.Checked = check;
    }
    public void CheckDir(bool check)
    {
      chkDir.Checked = check;
    }
    public void CheckDirImage(bool check)
    {
      chkDirImg.Checked = check;
    }

    public void Export(DoubleGrid costGrid, IntGrid dirGrid, Step step)
    {
      
      byte[] r = new byte[256];
      byte[] g = new byte[256];
      byte[] b = new byte[256];
      
      /*
      byte[] r = new byte[60];
      byte[] g = new byte[60];
      byte[] b = new byte[60];
      */
      Common.InitColors(r, g, b);

      if (costGrid != null)
      {
        if (CostGrid != null)
        { costGrid.Save(CostGrid); }
        if (CostImage != null)
        { ImageGrid.GridToTif(costGrid.ToIntGrid() % 256, CostImage, r, g, b); }
        //{ ImageGrid.GridToTif(costGrid.ToIntGrid() % 60, CostImage, r, g, b); }
      }
      if (dirGrid != null)
      {
        if (DirGrid != null)
        { dirGrid.Save(DirGrid); }
        if (DirImage != null)
        {
          // To fix colors in direction images. Added by Oystein
          /*r = new byte[256];
          g = new byte[256];
          b = new byte[256];*/
          Common.InitColors(r, g, b);

          // make sure that the start point cell returns a valid value for the step angle array
          IntGrid angleGrid = ((step[(dirGrid - 1).Abs() % step.Count] / Math.PI + 1.0) * 128).ToIntGrid();
          ImageGrid.GridToTif(angleGrid, DirImage, r, g, b);
        }
      }
    }

    public string FullName(string name)
    {
      if (name.IndexOf(Path.PathSeparator) < 0)
      {
        string full = Path.Combine(_mainPath, name);
        return full;
      }
      else
      {
        return name;
      }
    }

    public void Synchrone(TextBox orig)
    {
      if (chkSynchron.Checked == false)
      { return; }
      if (_inSynchron)
      { return; }

      try
      {
        _inSynchron = true;
        string sStamm = Path.GetFileNameWithoutExtension(orig.Text);
        if (sStamm.Length > 1)
        { sStamm = sStamm.Substring(0, sStamm.Length - 1); }
        txtCost.Text = sStamm + "c.grd";
        txtCostImg.Text = sStamm + "c.tif";
        txtDir.Text = sStamm + "d.grd";
        txtDirImg.Text = sStamm + "d.tif";
      }
      finally
      { _inSynchron = false; }
    }
    #region events
    private void btnCost_Click(object sender, EventArgs e)
    {
      try
      {
        dlgSave.Filter = "cost grid files (*c.grd)|*c.grd";
        if (dlgSave.ShowDialog() == DialogResult.OK)
        {
          txtCost.Text = dlgSave.FileName;
          Synchrone(txtCost);
        }
      }
      catch (Exception exp)
      { MessageBox.Show(exp.Message + "\n" + exp.StackTrace); }
    }

    private void btnCostImg_Click(object sender, EventArgs e)
    {
      try
      {
        dlgSave.Filter = "cost image files (*c.tif)|*c.tif";
        if (dlgSave.ShowDialog() == DialogResult.OK)
        {
          txtCostImg.Text = dlgSave.FileName;
          Synchrone(txtCostImg);
        }
      }
      catch (Exception exp)
      { MessageBox.Show(exp.Message + "\n" + exp.StackTrace); }
    }

    private void btnDir_Click(object sender, EventArgs e)
    {
      try
      {
        dlgSave.Filter = "direction grid files (*d.grd)|*d.grd";
        if (dlgSave.ShowDialog() == DialogResult.OK)
        {
          txtDir.Text = dlgSave.FileName;
          Synchrone(txtDir);
        }
      }
      catch (Exception exp)
      { MessageBox.Show(exp.Message + "\n" + exp.StackTrace); }
    }

    private void btnDirImg_Click(object sender, EventArgs e)
    {
      try
      {
        dlgSave.Filter = "direction image files (*d.tif)|*d.tif";
        if (dlgSave.ShowDialog() == DialogResult.OK)
        {
          txtDirImg.Text = dlgSave.FileName;
          Synchrone(txtDirImg);
        }
      }
      catch (Exception exp)
      { MessageBox.Show(exp.Message + "\n" + exp.StackTrace); }
    }

    private void txtCost_TextChanged(object sender, EventArgs e)
    {
      try
      {
        Synchrone(txtCost);
      }
      catch (Exception exp)
      { MessageBox.Show(exp.Message + "\n" + exp.StackTrace); }
    }

    private void txtCostImg_TextChanged(object sender, EventArgs e)
    {
      try
      {
        Synchrone(txtCostImg);
      }
      catch (Exception exp)
      { MessageBox.Show(exp.Message + "\n" + exp.StackTrace); }
    }

    private void txtDir_TextChanged(object sender, EventArgs e)
    {
      try
      {
        Synchrone(txtDir);
      }
      catch (Exception exp)
      { MessageBox.Show(exp.Message + "\n" + exp.StackTrace); }
    }

    private void txtDirImg_TextChanged(object sender, EventArgs e)
    {
      try
      {
        Synchrone(txtDirImg);
      }
      catch (Exception exp)
      { MessageBox.Show(exp.Message + "\n" + exp.StackTrace); }
    }
    #endregion
  }
}
