using System;
using System.Windows.Forms;
using Mathe.Geom;
using Grid;

namespace LeastCostPathUI
{
  public partial class WdgOutput : Form
  {
    private DoubleGrid _height;
    private Map _map;
    private double _resol;
    private Step _step;
    private StepCostHandler _stepCost;
    private Polyline _nearline;
    private double _corridorWidth;

    public WdgOutput()
    {
      InitializeComponent();
    }

    public void Init(DoubleGrid height, Map map,
      double resolution, Step step, StepCostHandler stepCost,
      Polyline nearline, double corridorWidth)
    {
      _height = height;
      _map = map;
      _resol = resolution;
      _step = step;
      _stepCost = stepCost;
      _nearline = nearline;
      _corridorWidth = corridorWidth;
    }

    public void SetExtent(IBox box)
    {
      cntOutput.SetExtent(box);
    }
    public void SetStart(IPoint start)
    {
      cntOutput.SetStart(start);
    }
    public void SetEnd(IPoint end)
    {
      cntOutput.SetEnd(end);
    }

    public void SetNames(string from, string to)
    {
      cntOutput.SetNames(from, to);
    }

    public void SetMainPath(string mainPath)
    {
      cntOutput.SetMainPath(mainPath);
    }

    private void btnCancel_Click(object sender, EventArgs e)
    {
      Hide();
      Close();
    }

    private bool _calc;
    private void btnOK_Click(object sender, EventArgs e)
    {
      if (_calc == false)
      {
        btnOK.Text = "Cancel";
        _calc = true;
        try
        {
          cntOutput.Calc(_height, _map, _resol, _step, _stepCost, _nearline, _corridorWidth);
        }
        finally
        {
          _calc = false;
          btnOK.Text = "OK";
        }
      }
      else
      {
        cntOutput.Cancel();
        _calc = false;
        btnOK.Text = "OK";
      }
    }
  }
}