using System.Data;

namespace Mathe.Data
{
  public class SchemaTablesTable : DataTable
  {
    public class Row : DataRow
    {
      internal Row(DataRowBuilder builder)
        : base(builder)
      { }

      public string TableName
      {
        get { return TableNameColumn.GetValue(this); }
        set { TableNameColumn.SetValue(this, value); }
      }
    }

    public static readonly TypedColumn<string> TableNameColumn = new TypedColumn<string>("TABLE_NAME");
    public SchemaTablesTable()
      : base("SchemaTables")
    {
      Columns.Add(TableNameColumn.CreateColumn());
    }

    public new Row NewRow()
    {
      return (Row)base.NewRow();
    }

    protected override DataRow NewRowFromBuilder(DataRowBuilder builder)
    {
      Row row = new Row(builder);
      return row;
    }

    public void AddRow(Row row)
    {
      Rows.Add(row);
    }
  }
}