using System.Data;

namespace Mathe.Data
{
  public class TypedColumn<T>
  {
    private readonly string _name;

    public TypedColumn(string name)
    {
      _name = name;
    }

    public string Name { get { return _name; } }

    public DataColumn CreateColumn()
    {
      DataColumn column = new DataColumn(_name, typeof(T));
      return column;
    }

    public T GetValue(DataRowView row)
    {
      return (T)row[_name];
    }
    public T GetValue(DataRow row)
    {
      return (T)row[_name];
    }

    public void SetValue(DataRow row, T value)
    {
      row[_name] = value;
    }
  }
}
