using System;
using System.Collections.Generic;
using Ocad;

namespace OCourse.Ext
{
  public class NextInfo
  {
    private string _where;
    public class EqualityComparer : IEqualityComparer<NextInfo>
    {
      public bool Equals(NextInfo x, NextInfo y)
      {
        bool equals = x.Control == y.Control && x.Where == y.Where;
        return equals;
      }

      public int GetHashCode(NextInfo obj)
      {
        int code = obj.Control.Name.GetHashCode();
        if (!string.IsNullOrEmpty(obj.Where))
        { code += 29 * obj.Where.GetHashCode(); }
        return code;
      }
    }

    public class EqualControlComparer : IEqualityComparer<NextInfo>
    {
      public bool Equals(NextInfo x, NextInfo y)
      {
        bool equals = x.Control == y.Control;
        return equals;
      }

      public int GetHashCode(NextInfo obj)
      {
        int code = obj.Control.Name.GetHashCode();
        return code;
      }
    }

    public string Where
    {
      get { return _where; }
      set { _where = value; }
    }
    public Control Control;
    public Char Code;

    public NextInfo()
    { }
    public NextInfo(Control control)
    {
      Control = control;
    }

    public override string ToString()
    {
      return string.Format("{0} {1}", Control, Where);
    }
  }
}