using System.Collections.Generic;
using Ocad;

namespace OCourse.Ext
{
  internal class NextInfoList
  {
    private List<NextInfo> _list = new List<NextInfo>();
    private bool _codesAssured;

    public int Count
    { get { return _list.Count; } }

    public List<NextInfo> List
    {
      get { return _list; }
    }

    public void AssureCodes()
    {
      if (_codesAssured)
      { return; }

      Dictionary<NextInfo, List<NextInfo>> dict =
        new Dictionary<NextInfo, List<NextInfo>>(new NextInfo.EqualityComparer());
      foreach (NextInfo next in _list)
      {
        List<NextInfo> nextList;
        if (!dict.TryGetValue(next, out nextList))
        {
          nextList = new List<NextInfo>();
          dict.Add(next, nextList);
        }
        nextList.Add(next);
      }
      if (dict.Count > 1)
      {
        char code = 'A';
        code--;
        foreach (List<NextInfo> nextList in dict.Values)
        {
          code++;
          foreach (NextInfo next in nextList)
          {
            next.Code = code;
          }
        }
      }
      _codesAssured = true;
    }
    public NextInfo Add(SimpleSection section)
    {
      NextInfo newNext = new NextInfo();
      newNext.Control = section.To;
      newNext.Where = section.Where;
      _list.Add(newNext);

      return newNext;
    }

    public NextInfoList Clone()
    {
      NextInfoList clone = new NextInfoList();
      clone._codesAssured = _codesAssured;
      clone._list = new List<NextInfo>(_list);

      return clone;
    }
  }
}