﻿using System.Collections.Generic;
using System.Data;
using System.IO;
using Ocad;

namespace OCourse.Ext
{
  partial class Settings
  {
    private string _courseFile;

    public string CourseFile
    {
      get { return _courseFile; }
      set { _courseFile = value; }
    }

    public static Settings GetSettings(string orig)
    {
      using (OcadReader reader = OcadReader.Open(orig))
      {
        Settings settings = GetSettings(reader, null);
        return settings;
      }
    }

    public static Settings GetSettings(OcadReader reader, IList<ElementIndex> indexList)
    {
      foreach (Element element in reader.Elements(false, indexList))
      {
        if (element.Symbol == 723000)
        {
          string eText = element.Text;

          MemoryStream stream = new MemoryStream();
          MemoryStream read = new MemoryStream();
          using (TextWriter w = new StreamWriter(stream))
          {
            w.WriteLine("<Settings xmlns=\"http://tempuri.org/Settings.xsd\">");
            w.WriteLine(eText);
            w.WriteLine("</Settings>");
            w.Flush();

            stream.WriteTo(read);
          }

          read.Seek(0, SeekOrigin.Begin);

          DataSet importDs = new DataSet();
          importDs.ReadXml(read, XmlReadMode.InferSchema);

          Settings settings = new Settings();
          foreach (DataRow row in importDs.Tables[settings.Layout.TableName].Rows)
          {
            settings.Layout.ImportRow(row);
          }
          return settings;
        }
      }
      return null;
    }
  }
}
