
using System;
using System.Data;
using System.Data.Common;
using Mathe.Data;

namespace Ocad.Data
{
  public sealed class OcadCommand : DbBaseCommand
  {
    private OcadTransaction _transaction;

    public OcadCommand(OcadConnection connection)
      : base(connection)
    { }

    public new OcadConnection Connection
    {
      get { return (OcadConnection)DbConnection; }
      set { DbConnection = value; }
    }

    protected override DbConnection DbConnection
    {
      get { return base.Connection; }
      set
      {
        OcadConnection connection = (OcadConnection)value;
        base.DbConnection = connection;
      }
    }

    public new OcadTransaction Transaction
    {
      get { return _transaction; }
      set { _transaction = value; }
    }
    protected override DbTransaction DbTransaction
    {
      get { return Transaction; }
      set { Transaction = (OcadTransaction)value; }
    }

    public new OcadDbReader ExecuteReader()
    { return ExecuteReader(CommandBehavior.Default); }
    public new OcadDbReader ExecuteReader(CommandBehavior behavior)
    { return (OcadDbReader)ExecuteDbDataReader(behavior); }

    protected override DbDataReader ExecuteDbDataReader(CommandBehavior behavior)
    {
      OcadDbReader reader = new OcadDbReader(this, behavior);
      return reader;
    }

    protected override int ExecuteUpdate(UpdateCommand update)
    { throw new NotImplementedException(); }
    protected override int ExecuteInsert(InsertCommand insert)
    { throw new NotImplementedException(); }
    protected override int ExecuteDelete(DeleteCommand delete)
    { throw new NotImplementedException(); }

    public override System.Collections.IEnumerable GetRows(string filter)
    {
      throw new Exception("The method or operation is not implemented.");
    }
  }
}
