
namespace Ocad.StringParams
{
  public class ColorPar : MultiParam
  {
    public const char NumberKey = 'n';
    public const char CyanKey = 'c';
    public const char MagentaKey = 'm';
    public const char YellowKey = 'y';
    public const char BlackKey = 'k';
    public const char OverprintKey = 'o';
    public const char TransparencyKey = 't';

    public const char SpotColorSeparationNameKey = 's';
    public const char PercentageSpotColorKey = 'p';

    public ColorPar(string para)
      : base(para)
    { }

    public int Number
    {
      get { return GetInt(NumberKey).Value; }
      set { SetParam(NumberKey, value); }
    }

    public int Cyan
    {
      get { return GetInt(CyanKey).Value; }
      set { SetParam(CyanKey, value); }
    }

    public int Magenta
    {
      get { return GetInt(MagentaKey).Value; }
      set { SetParam(MagentaKey, value); }
    }
    public int Yellow
    {
      get { int? y = GetInt(YellowKey); return y ?? 0; }
      set { SetParam(YellowKey, value); }
    }

    public int Black
    {
      get { int? b = GetInt(BlackKey); return b ?? 0; }
      set { SetParam(BlackKey, value); }
    }
  }
}
