using System;
using System.Collections;

namespace Ocad
{
  /// <summary>
  /// Summary description for PrintPar
  /// </summary>
  public class PrintPar : StringPar
  {
    public enum RangeType 
    {
      EntireMap = 0,PartialMap = 1, OnePage = 2
    }

    public PrintPar() : base(false)
    {	}
    public PrintPar(string stringParam) : base(stringParam, false)
    { }
    public double Scale
    {
      get
      { return Convert.ToDouble(_params['a']); }
      set
      { SetParam('a',value); }
    }
    public RangeType Range
    {
      get
      { return (RangeType) Convert.ToInt32(_params['r']); }
      set
      { SetParam('r',(int) value); }
    }

    public double Left
    {
      get
      { return Convert.ToDouble(_params['L']); }
      set
      { SetParam('L',value); }
    }
    public double Right
    {
      get
      { return Convert.ToDouble(_params['R']); }
      set
      { SetParam('R',value); }
    }
    public double Top
    {
      get
      { return Convert.ToDouble(_params['T']); }
      set
      { SetParam('T',value); }
    }
    public double Bottom
    {
      get
      { return Convert.ToDouble(_params['B']); }
      set
      { SetParam('B',value); }
    }
  }
}
