using System;
using System.Collections;

namespace Ocad
{
	/// <summary>
	/// Summary description for StringParam.
	/// </summary>
	public abstract class StringPar
	{
    private bool _isNamed;
    private string _name;
    private string _stringParam;
    protected Hashtable _params = new Hashtable();

		protected StringPar(bool named)
		{
      _isNamed = named;
		}
    protected StringPar(string parameters, bool named)
    {
      _isNamed = named;
      StringParam = parameters;
    }

    public string Name
    {
      get
      { return _name; }
      set
      { _name = value; }
    }

    protected void SetParam(char key,object value)
    {
      _stringParam = null;
      if (_params.ContainsKey(key))
      { _params[key] = value; }
      else
      { _params.Add(key,value); }
    }

    protected int? GetInt(object value)
    {
      if (value == null)
      { return null; }
      if (value is string && string.IsNullOrEmpty((string)value))
      { return null; }
      return Convert.ToInt32(value);
    }
    public string StringParam
    {
      get
      {
        if (_stringParam == null)
        {
          if (_isNamed)
          { _stringParam = _name; }
          else
          { _stringParam = ""; }

          foreach (char key in _params.Keys)
          { _stringParam += string.Format("\t{0}{1}",key,_params[key]); }

          _stringParam = _stringParam + "\t\t";
        }
        return _stringParam;
      }
      set
      {
        _stringParam = null;
        _params = new Hashtable();

        string[] sParams = value.Split('\t');

        if (_isNamed)
        { _name = sParams[0]; }

        bool bFirst = true && _isNamed;
        foreach (string sName in sParams)
        {
          if (bFirst)
          {
            bFirst = false;
            continue;
          }
          if (sName == null || sName == "" )
          { continue; }
          else
          { _params.Add(sName[0],sName.Substring(1)); }
        }
      }
    }
	}
}
