
using System;
using System.Data;
using System.Data.Common;
using Mathe.Data;

namespace Shape.Data
{
  public sealed class ShapeCommand : DbBaseCommand
  {
    private ShapeTransaction _transaction;

    public ShapeCommand(ShapeConnection connection)
      : base(connection)
    { }

    public new ShapeConnection Connection
    {
      get { return (ShapeConnection)DbConnection; }
      set { DbConnection = value; }
    }

    protected override DbConnection DbConnection
    {
      get { return base.Connection; }
      set
      {
        ShapeConnection connection = (ShapeConnection)value;
        base.DbConnection = connection;
      }
    }

    public new ShapeTransaction Transaction
    {
      get { return _transaction; }
      set { _transaction = value; }
    }
    protected override DbTransaction DbTransaction
    {
      get { return Transaction; }
      set { Transaction = (ShapeTransaction)value; }
    }

    public new ShapeDbReader ExecuteReader()
    { return ExecuteReader(CommandBehavior.Default); }
    public new ShapeDbReader ExecuteReader(CommandBehavior behavior)
    { return (ShapeDbReader)ExecuteDbDataReader(behavior); }

    protected override DbDataReader ExecuteDbDataReader(CommandBehavior behavior)
    {
      ShapeDbReader reader = new ShapeDbReader(this, behavior);
      return reader;
    }

    protected override int ExecuteUpdate(UpdateCommand update)
    { throw new NotImplementedException(); }
    protected override int ExecuteInsert(InsertCommand insert)
    { throw new NotImplementedException(); }
    protected override int ExecuteDelete(DeleteCommand delete)
    { throw new NotImplementedException(); }

    public override System.Collections.IEnumerable GetRows(string filter)
    {
      throw new Exception("The method or operation is not implemented.");
    }

    public string GetFullName()
    {
      string fullName = System.IO.Path.Combine(Connection.ConnectionString, TableName);
      return fullName;
    }
  }
}
